(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: genr_nary.mli,v 1.2 2008/02/11 23:05:59 weis Exp $ *)

(** {3 Construction functions for n-ary generators.} *)

val genr_function : Genr_base.function_definition ->
  (Code.lident * Code.pattern list * Code.exp) list
(** We treat the case of n-ary generators.

    Let's [g] be such a generator; we generate a n-ary function (here n-ary
    means that the function has a n-tuple as unique argument) that normalizes
    terms that are built with [g] as their head constructor. *)
;;
