(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Pierre Weis, INRIA Rocquencourt                           *)
(*          Frdric Blanqui, projet Protheo, INRIA Lorraine          *)
(*                                                                    *)
(*  Copyright 2005-2008,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* symbols *)

type symb = int;;

open Useful;;

module SymbSet = IntSet;;
module SymbMap = IntMap;;

let symbol_of_string, string_of_symbol, clear_symbols =
  let symap = ref SymbMap.empty
  and stmap = ref StrMap.empty
  and n = ref 0 in
    (fun s ->
       (try StrMap.find s !stmap
	with Not_found ->
	  incr n;
	  stmap := StrMap.add s !n !stmap;
	  symap := SymbMap.add !n s !symap;
	  !n)),
    (fun n -> SymbMap.find n !symap),
    (fun () ->
       symap := SymbMap.empty;
       stmap := StrMap.empty;
       n := 0)
;;
