(**********************************************************************)
(*                                                                    *)
(*                           Moca                                     *)
(*                                                                    *)
(*          Laura Lowenthal, projet Protheo, INRIA Lorraine           *)
(*                                                                    *)
(*  Copyright 2005-2007,                                              *)
(*  Institut National de Recherche en Informatique et en Automatique. *)
(*  All rights reserved.                                              *)
(*                                                                    *)
(*  This file is distributed under the terms of the Q Public License. *)
(*                                                                    *)
(**********************************************************************)

(* $Id: genr_equalities.mli,v 1.4 2007/12/13 15:34:32 lowenthl Exp $ *)

(** {Generation of equalities on values, deduced from moca relations.} *)


val genr_values_and_equalities :
  int -> (Parsetree.core_type -> int -> Code.exp list) ->
  string * Parsetree.core_type list * Parsetree.relations * Location.t -> Code.exp list
;;
(** Given a number n of equalities, a function generating values of a given type, and a constructor definition, generates equalities that must hold according to the relations specified for the constructor. Generates n equalities per equation deduced from the relations. Equalities are of the form
 let v1 = example_value1 in
 let v2 = example_value2 in
 ...
 left_side = right_side
*)